/* ide-vala-locator.c generated by valac 0.42.2, the Vala compiler
 * generated from ide-vala-locator.vala, do not modify */

/*
 * Copyright 2008 Abderrahim Kitouni
 * Copyright 2015 Christian Hergert <christian@hergert.me>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Finds the innermost block containing the given location */


#include <glib.h>
#include <glib-object.h>
#include <vala.h>
#include <valagee.h>
#include <string.h>


#define IDE_TYPE_VALA_LOCATOR (ide_vala_locator_get_type ())
#define IDE_VALA_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IDE_TYPE_VALA_LOCATOR, IdeValaLocator))
#define IDE_VALA_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IDE_TYPE_VALA_LOCATOR, IdeValaLocatorClass))
#define IDE_IS_VALA_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IDE_TYPE_VALA_LOCATOR))
#define IDE_IS_VALA_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IDE_TYPE_VALA_LOCATOR))
#define IDE_VALA_LOCATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IDE_TYPE_VALA_LOCATOR, IdeValaLocatorClass))

typedef struct _IdeValaLocator IdeValaLocator;
typedef struct _IdeValaLocatorClass IdeValaLocatorClass;
typedef struct _IdeValaLocatorPrivate IdeValaLocatorPrivate;

#define IDE_VALA_LOCATOR_TYPE_LOCATION (ide_vala_locator_location_get_type ())
typedef struct _IdeValaLocatorLocation IdeValaLocatorLocation;
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))

struct _IdeValaLocator {
	ValaCodeVisitor parent_instance;
	IdeValaLocatorPrivate * priv;
};

struct _IdeValaLocatorClass {
	ValaCodeVisitorClass parent_class;
};

struct _IdeValaLocatorLocation {
	gint line;
	gint column;
};

struct _IdeValaLocatorPrivate {
	IdeValaLocatorLocation location;
	ValaSymbol* innermost;
	IdeValaLocatorLocation innermost_begin;
	IdeValaLocatorLocation innermost_end;
};


static gint IdeValaLocator_private_offset;
static gpointer ide_vala_locator_parent_class = NULL;
static GType ide_vala_locator_type_id = 0;

GType ide_vala_locator_get_type (void) G_GNUC_CONST;
static GType ide_vala_locator_location_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static IdeValaLocatorLocation* ide_vala_locator_location_dup (const IdeValaLocatorLocation* self);
static void ide_vala_locator_location_free (IdeValaLocatorLocation* self);
ValaSymbol* ide_vala_locator_locate (IdeValaLocator* self,
                                     ValaSourceFile* file,
                                     gint line,
                                     gint column);
static void ide_vala_locator_location_init (IdeValaLocatorLocation *self,
                                     gint line,
                                     gint column);
static gboolean ide_vala_locator_update_location (IdeValaLocator* self,
                                           ValaSymbol* s);
static gboolean ide_vala_locator_location_inside (IdeValaLocatorLocation *self,
                                           ValaSourceReference* src);
static gboolean ide_vala_locator_location_before (IdeValaLocatorLocation *self,
                                           IdeValaLocatorLocation* other);
static void ide_vala_locator_real_visit_block (ValaCodeVisitor* base,
                                        ValaBlock* b);
static void ide_vala_locator_real_visit_namespace (ValaCodeVisitor* base,
                                            ValaNamespace* ns);
static void ide_vala_locator_real_visit_class (ValaCodeVisitor* base,
                                        ValaClass* cl);
static void ide_vala_locator_real_visit_struct (ValaCodeVisitor* base,
                                         ValaStruct* st);
static void ide_vala_locator_real_visit_interface (ValaCodeVisitor* base,
                                            ValaInterface* iface);
static void ide_vala_locator_real_visit_method (ValaCodeVisitor* base,
                                         ValaMethod* m);
static void ide_vala_locator_real_visit_creation_method (ValaCodeVisitor* base,
                                                  ValaCreationMethod* m);
static void ide_vala_locator_real_visit_property (ValaCodeVisitor* base,
                                           ValaProperty* prop);
static void ide_vala_locator_real_visit_property_accessor (ValaCodeVisitor* base,
                                                    ValaPropertyAccessor* acc);
static void ide_vala_locator_real_visit_constructor (ValaCodeVisitor* base,
                                              ValaConstructor* c);
static void ide_vala_locator_real_visit_destructor (ValaCodeVisitor* base,
                                             ValaDestructor* d);
static void ide_vala_locator_real_visit_if_statement (ValaCodeVisitor* base,
                                               ValaIfStatement* stmt);
static void ide_vala_locator_real_visit_switch_statement (ValaCodeVisitor* base,
                                                   ValaSwitchStatement* stmt);
static void ide_vala_locator_real_visit_switch_section (ValaCodeVisitor* base,
                                                 ValaSwitchSection* section);
static void ide_vala_locator_real_visit_while_statement (ValaCodeVisitor* base,
                                                  ValaWhileStatement* stmt);
static void ide_vala_locator_real_visit_do_statement (ValaCodeVisitor* base,
                                               ValaDoStatement* stmt);
static void ide_vala_locator_real_visit_for_statement (ValaCodeVisitor* base,
                                                ValaForStatement* stmt);
static void ide_vala_locator_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                    ValaForeachStatement* stmt);
static void ide_vala_locator_real_visit_try_statement (ValaCodeVisitor* base,
                                                ValaTryStatement* stmt);
static void ide_vala_locator_real_visit_catch_clause (ValaCodeVisitor* base,
                                               ValaCatchClause* clause);
static void ide_vala_locator_real_visit_lock_statement (ValaCodeVisitor* base,
                                                 ValaLockStatement* stmt);
static void ide_vala_locator_real_visit_expression_statement (ValaCodeVisitor* base,
                                                       ValaExpressionStatement* stmt);
static void ide_vala_locator_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                        ValaDeclarationStatement* stmt);
static void ide_vala_locator_real_visit_local_variable (ValaCodeVisitor* base,
                                                 ValaLocalVariable* variable);
static void ide_vala_locator_real_visit_end_full_expression (ValaCodeVisitor* base,
                                                      ValaExpression* expr);
static void ide_vala_locator_real_visit_expression (ValaCodeVisitor* base,
                                             ValaExpression* expr);
IdeValaLocator* ide_vala_locator_new (void);
IdeValaLocator* ide_vala_locator_construct (GType object_type);
static void ide_vala_locator_finalize (ValaCodeVisitor * obj);


static inline gpointer
ide_vala_locator_get_instance_private (IdeValaLocator* self)
{
	return G_STRUCT_MEMBER_P (self, IdeValaLocator_private_offset);
}


static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}


ValaSymbol*
ide_vala_locator_locate (IdeValaLocator* self,
                         ValaSourceFile* file,
                         gint line,
                         gint column)
{
	ValaSymbol* result = NULL;
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	ide_vala_locator_location_init (&self->priv->location, line, column);
	_vala_code_node_unref0 (self->priv->innermost);
	self->priv->innermost = NULL;
	vala_source_file_accept_children (file, (ValaCodeVisitor*) self);
	_tmp0_ = self->priv->innermost;
	_tmp1_ = _vala_code_node_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


static gboolean
ide_vala_locator_update_location (IdeValaLocator* self,
                                  ValaSymbol* s)
{
	gboolean result = FALSE;
	ValaSourceReference* _tmp0_;
	ValaSourceReference* _tmp1_;
	IdeValaLocatorLocation begin = {0};
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaSourceLocation _tmp4_ = {0};
	ValaSourceLocation _tmp5_;
	gint _tmp6_;
	ValaSourceReference* _tmp7_;
	ValaSourceReference* _tmp8_;
	ValaSourceLocation _tmp9_ = {0};
	ValaSourceLocation _tmp10_;
	gint _tmp11_;
	IdeValaLocatorLocation end = {0};
	ValaSourceReference* _tmp12_;
	ValaSourceReference* _tmp13_;
	ValaSourceLocation _tmp14_ = {0};
	ValaSourceLocation _tmp15_;
	gint _tmp16_;
	ValaSourceReference* _tmp17_;
	ValaSourceReference* _tmp18_;
	ValaSourceLocation _tmp19_ = {0};
	ValaSourceLocation _tmp20_;
	gint _tmp21_;
	gboolean _tmp22_ = FALSE;
	ValaSymbol* _tmp23_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (s != NULL, FALSE);
	_tmp0_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
	_tmp1_ = _tmp0_;
	if (!ide_vala_locator_location_inside (&self->priv->location, _tmp1_)) {
		result = FALSE;
		return result;
	}
	_tmp2_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
	_tmp3_ = _tmp2_;
	vala_source_reference_get_begin (_tmp3_, &_tmp4_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_.line;
	_tmp7_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
	_tmp8_ = _tmp7_;
	vala_source_reference_get_begin (_tmp8_, &_tmp9_);
	_tmp10_ = _tmp9_;
	_tmp11_ = _tmp10_.column;
	ide_vala_locator_location_init (&begin, _tmp6_, _tmp11_);
	_tmp12_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
	_tmp13_ = _tmp12_;
	vala_source_reference_get_end (_tmp13_, &_tmp14_);
	_tmp15_ = _tmp14_;
	_tmp16_ = _tmp15_.line;
	_tmp17_ = vala_code_node_get_source_reference ((ValaCodeNode*) s);
	_tmp18_ = _tmp17_;
	vala_source_reference_get_end (_tmp18_, &_tmp19_);
	_tmp20_ = _tmp19_;
	_tmp21_ = _tmp20_.column;
	ide_vala_locator_location_init (&end, _tmp16_, _tmp21_);
	_tmp23_ = self->priv->innermost;
	if (_tmp23_ == NULL) {
		_tmp22_ = TRUE;
	} else {
		gboolean _tmp24_ = FALSE;
		IdeValaLocatorLocation _tmp25_;
		_tmp25_ = begin;
		if (ide_vala_locator_location_before (&self->priv->innermost_begin, &_tmp25_)) {
			IdeValaLocatorLocation _tmp26_;
			_tmp26_ = self->priv->innermost_end;
			_tmp24_ = ide_vala_locator_location_before (&end, &_tmp26_);
		} else {
			_tmp24_ = FALSE;
		}
		_tmp22_ = _tmp24_;
	}
	if (_tmp22_) {
		ValaSymbol* _tmp27_;
		IdeValaLocatorLocation _tmp28_;
		IdeValaLocatorLocation _tmp29_;
		_tmp27_ = _vala_code_node_ref0 (s);
		_vala_code_node_unref0 (self->priv->innermost);
		self->priv->innermost = _tmp27_;
		_tmp28_ = begin;
		self->priv->innermost_begin = _tmp28_;
		_tmp29_ = end;
		self->priv->innermost_end = _tmp29_;
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static void
ide_vala_locator_real_visit_block (ValaCodeVisitor* base,
                                   ValaBlock* b)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (b != NULL);
	if (ide_vala_locator_update_location (self, (ValaSymbol*) b)) {
		vala_code_node_accept_children ((ValaCodeNode*) b, (ValaCodeVisitor*) self);
	}
}


static void
ide_vala_locator_real_visit_namespace (ValaCodeVisitor* base,
                                       ValaNamespace* ns)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (ns != NULL);
	ide_vala_locator_update_location (self, (ValaSymbol*) ns);
	vala_code_node_accept_children ((ValaCodeNode*) ns, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_class (ValaCodeVisitor* base,
                                   ValaClass* cl)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (cl != NULL);
	if (ide_vala_locator_update_location (self, (ValaSymbol*) cl)) {
		return;
	}
	vala_code_node_accept_children ((ValaCodeNode*) cl, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_struct (ValaCodeVisitor* base,
                                    ValaStruct* st)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (st != NULL);
	if (ide_vala_locator_update_location (self, (ValaSymbol*) st)) {
		return;
	}
	vala_code_node_accept_children ((ValaCodeNode*) st, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_interface (ValaCodeVisitor* base,
                                       ValaInterface* iface)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (iface != NULL);
	if (ide_vala_locator_update_location (self, (ValaSymbol*) iface)) {
		return;
	}
	vala_code_node_accept_children ((ValaCodeNode*) iface, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_method (ValaCodeVisitor* base,
                                    ValaMethod* m)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (m != NULL);
	if (ide_vala_locator_update_location (self, (ValaSymbol*) m)) {
		return;
	}
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_creation_method (ValaCodeVisitor* base,
                                             ValaCreationMethod* m)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (m != NULL);
	if (ide_vala_locator_update_location (self, (ValaSymbol*) m)) {
		return;
	}
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_property (ValaCodeVisitor* base,
                                      ValaProperty* prop)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (prop != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) prop, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_property_accessor (ValaCodeVisitor* base,
                                               ValaPropertyAccessor* acc)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (acc != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) acc, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_constructor (ValaCodeVisitor* base,
                                         ValaConstructor* c)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (c != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_destructor (ValaCodeVisitor* base,
                                        ValaDestructor* d)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (d != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) d, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_if_statement (ValaCodeVisitor* base,
                                          ValaIfStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_switch_statement (ValaCodeVisitor* base,
                                              ValaSwitchStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_switch_section (ValaCodeVisitor* base,
                                            ValaSwitchSection* section)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (section != NULL);
	vala_code_visitor_visit_block ((ValaCodeVisitor*) self, (ValaBlock*) section);
}


static void
ide_vala_locator_real_visit_while_statement (ValaCodeVisitor* base,
                                             ValaWhileStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_do_statement (ValaCodeVisitor* base,
                                          ValaDoStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_for_statement (ValaCodeVisitor* base,
                                           ValaForStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_foreach_statement (ValaCodeVisitor* base,
                                               ValaForeachStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_try_statement (ValaCodeVisitor* base,
                                           ValaTryStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_catch_clause (ValaCodeVisitor* base,
                                          ValaCatchClause* clause)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (clause != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) clause, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_lock_statement (ValaCodeVisitor* base,
                                            ValaLockStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_expression_statement (ValaCodeVisitor* base,
                                                  ValaExpressionStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                   ValaDeclarationStatement* stmt)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (stmt != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_local_variable (ValaCodeVisitor* base,
                                            ValaLocalVariable* variable)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (variable != NULL);
	vala_code_node_accept_children ((ValaCodeNode*) variable, (ValaCodeVisitor*) self);
}


static void
ide_vala_locator_real_visit_end_full_expression (ValaCodeVisitor* base,
                                                 ValaExpression* expr)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (expr != NULL);
	if (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_LAMBDA_EXPRESSION)) {
		ValaMethod* _tmp0_;
		ValaMethod* _tmp1_;
		_tmp0_ = vala_lambda_expression_get_method (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_LAMBDA_EXPRESSION) ? ((ValaLambdaExpression*) expr) : NULL);
		_tmp1_ = _tmp0_;
		if (_tmp1_ != NULL) {
			ValaMethod* _tmp2_;
			ValaMethod* _tmp3_;
			_tmp2_ = vala_lambda_expression_get_method (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_LAMBDA_EXPRESSION) ? ((ValaLambdaExpression*) expr) : NULL);
			_tmp3_ = _tmp2_;
			vala_code_visitor_visit_method ((ValaCodeVisitor*) self, _tmp3_);
		}
	}
	if (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_METHOD_CALL)) {
		{
			ValaList* _e_list = NULL;
			ValaList* _tmp4_;
			gint _e_size = 0;
			ValaList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _e_index = 0;
			_tmp4_ = vala_method_call_get_argument_list (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_METHOD_CALL) ? ((ValaMethodCall*) expr) : NULL);
			_e_list = _tmp4_;
			_tmp5_ = _e_list;
			_tmp6_ = vala_collection_get_size ((ValaCollection*) _tmp5_);
			_tmp7_ = _tmp6_;
			_e_size = _tmp7_;
			_e_index = -1;
			while (TRUE) {
				gint _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				ValaExpression* e = NULL;
				ValaList* _tmp11_;
				gint _tmp12_;
				gpointer _tmp13_;
				ValaExpression* _tmp14_;
				_tmp8_ = _e_index;
				_e_index = _tmp8_ + 1;
				_tmp9_ = _e_index;
				_tmp10_ = _e_size;
				if (!(_tmp9_ < _tmp10_)) {
					break;
				}
				_tmp11_ = _e_list;
				_tmp12_ = _e_index;
				_tmp13_ = vala_list_get (_tmp11_, _tmp12_);
				e = (ValaExpression*) _tmp13_;
				_tmp14_ = e;
				vala_code_visitor_visit_expression ((ValaCodeVisitor*) self, _tmp14_);
				_vala_code_node_unref0 (e);
			}
			_vala_iterable_unref0 (_e_list);
		}
	}
}


static void
ide_vala_locator_real_visit_expression (ValaCodeVisitor* base,
                                        ValaExpression* expr)
{
	IdeValaLocator * self;
	self = (IdeValaLocator*) base;
	g_return_if_fail (expr != NULL);
	if (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_LAMBDA_EXPRESSION)) {
		ValaMethod* _tmp0_;
		ValaMethod* _tmp1_;
		_tmp0_ = vala_lambda_expression_get_method (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_LAMBDA_EXPRESSION) ? ((ValaLambdaExpression*) expr) : NULL);
		_tmp1_ = _tmp0_;
		if (_tmp1_ != NULL) {
			ValaMethod* _tmp2_;
			ValaMethod* _tmp3_;
			_tmp2_ = vala_lambda_expression_get_method (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_LAMBDA_EXPRESSION) ? ((ValaLambdaExpression*) expr) : NULL);
			_tmp3_ = _tmp2_;
			vala_code_visitor_visit_method ((ValaCodeVisitor*) self, _tmp3_);
		}
	}
	if (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_METHOD_CALL)) {
		{
			ValaList* _e_list = NULL;
			ValaList* _tmp4_;
			gint _e_size = 0;
			ValaList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _e_index = 0;
			_tmp4_ = vala_method_call_get_argument_list (G_TYPE_CHECK_INSTANCE_TYPE (expr, VALA_TYPE_METHOD_CALL) ? ((ValaMethodCall*) expr) : NULL);
			_e_list = _tmp4_;
			_tmp5_ = _e_list;
			_tmp6_ = vala_collection_get_size ((ValaCollection*) _tmp5_);
			_tmp7_ = _tmp6_;
			_e_size = _tmp7_;
			_e_index = -1;
			while (TRUE) {
				gint _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				ValaExpression* e = NULL;
				ValaList* _tmp11_;
				gint _tmp12_;
				gpointer _tmp13_;
				ValaExpression* _tmp14_;
				_tmp8_ = _e_index;
				_e_index = _tmp8_ + 1;
				_tmp9_ = _e_index;
				_tmp10_ = _e_size;
				if (!(_tmp9_ < _tmp10_)) {
					break;
				}
				_tmp11_ = _e_list;
				_tmp12_ = _e_index;
				_tmp13_ = vala_list_get (_tmp11_, _tmp12_);
				e = (ValaExpression*) _tmp13_;
				_tmp14_ = e;
				vala_code_visitor_visit_expression ((ValaCodeVisitor*) self, _tmp14_);
				_vala_code_node_unref0 (e);
			}
			_vala_iterable_unref0 (_e_list);
		}
	}
}


IdeValaLocator*
ide_vala_locator_construct (GType object_type)
{
	IdeValaLocator* self = NULL;
	self = (IdeValaLocator*) vala_code_visitor_construct (object_type);
	return self;
}


IdeValaLocator*
ide_vala_locator_new (void)
{
	return ide_vala_locator_construct (IDE_TYPE_VALA_LOCATOR);
}


static void
ide_vala_locator_location_init (IdeValaLocatorLocation *self,
                                gint line,
                                gint column)
{
	memset (self, 0, sizeof (IdeValaLocatorLocation));
	(*self).line = line;
	(*self).column = column;
}


static gboolean
ide_vala_locator_location_inside (IdeValaLocatorLocation *self,
                                  ValaSourceReference* src)
{
	gboolean result = FALSE;
	IdeValaLocatorLocation begin = {0};
	ValaSourceLocation _tmp0_ = {0};
	ValaSourceLocation _tmp1_;
	gint _tmp2_;
	ValaSourceLocation _tmp3_ = {0};
	ValaSourceLocation _tmp4_;
	gint _tmp5_;
	IdeValaLocatorLocation end = {0};
	ValaSourceLocation _tmp6_ = {0};
	ValaSourceLocation _tmp7_;
	gint _tmp8_;
	ValaSourceLocation _tmp9_ = {0};
	ValaSourceLocation _tmp10_;
	gint _tmp11_;
	gboolean _tmp12_ = FALSE;
	g_return_val_if_fail (src != NULL, FALSE);
	vala_source_reference_get_begin (src, &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_.line;
	vala_source_reference_get_begin (src, &_tmp3_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_.column;
	ide_vala_locator_location_init (&begin, _tmp2_, _tmp5_);
	vala_source_reference_get_end (src, &_tmp6_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _tmp7_.line;
	vala_source_reference_get_end (src, &_tmp9_);
	_tmp10_ = _tmp9_;
	_tmp11_ = _tmp10_.column;
	ide_vala_locator_location_init (&end, _tmp8_, _tmp11_);
	if (ide_vala_locator_location_before (&begin, &(*self))) {
		IdeValaLocatorLocation _tmp13_;
		_tmp13_ = end;
		_tmp12_ = ide_vala_locator_location_before (&(*self), &_tmp13_);
	} else {
		_tmp12_ = FALSE;
	}
	result = _tmp12_;
	return result;
}


static gboolean
ide_vala_locator_location_before (IdeValaLocatorLocation *self,
                                  IdeValaLocatorLocation* other)
{
	gboolean result = FALSE;
	gint _tmp0_;
	IdeValaLocatorLocation _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (other != NULL, FALSE);
	_tmp0_ = (*self).line;
	_tmp1_ = *other;
	_tmp2_ = _tmp1_.line;
	if (_tmp0_ > _tmp2_) {
		result = FALSE;
		return result;
	} else {
		gboolean _tmp3_ = FALSE;
		gint _tmp4_;
		IdeValaLocatorLocation _tmp5_;
		gint _tmp6_;
		_tmp4_ = (*self).line;
		_tmp5_ = *other;
		_tmp6_ = _tmp5_.line;
		if (_tmp4_ == _tmp6_) {
			gint _tmp7_;
			IdeValaLocatorLocation _tmp8_;
			gint _tmp9_;
			_tmp7_ = (*self).column;
			_tmp8_ = *other;
			_tmp9_ = _tmp8_.column;
			_tmp3_ = _tmp7_ > _tmp9_;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			result = FALSE;
			return result;
		}
	}
	result = TRUE;
	return result;
}


static IdeValaLocatorLocation*
ide_vala_locator_location_dup (const IdeValaLocatorLocation* self)
{
	IdeValaLocatorLocation* dup;
	dup = g_new0 (IdeValaLocatorLocation, 1);
	memcpy (dup, self, sizeof (IdeValaLocatorLocation));
	return dup;
}


static void
ide_vala_locator_location_free (IdeValaLocatorLocation* self)
{
	g_free (self);
}


static GType
ide_vala_locator_location_get_type (void)
{
	static volatile gsize ide_vala_locator_location_type_id__volatile = 0;
	if (g_once_init_enter (&ide_vala_locator_location_type_id__volatile)) {
		GType ide_vala_locator_location_type_id;
		ide_vala_locator_location_type_id = g_boxed_type_register_static ("IdeValaLocatorLocation", (GBoxedCopyFunc) ide_vala_locator_location_dup, (GBoxedFreeFunc) ide_vala_locator_location_free);
		g_once_init_leave (&ide_vala_locator_location_type_id__volatile, ide_vala_locator_location_type_id);
	}
	return ide_vala_locator_location_type_id__volatile;
}


static void
ide_vala_locator_class_init (IdeValaLocatorClass * klass)
{
	ide_vala_locator_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeVisitorClass *) klass)->finalize = ide_vala_locator_finalize;
	g_type_class_adjust_private_offset (klass, &IdeValaLocator_private_offset);
	((ValaCodeVisitorClass *) klass)->visit_block = (void (*) (ValaCodeVisitor *, ValaBlock*)) ide_vala_locator_real_visit_block;
	((ValaCodeVisitorClass *) klass)->visit_namespace = (void (*) (ValaCodeVisitor *, ValaNamespace*)) ide_vala_locator_real_visit_namespace;
	((ValaCodeVisitorClass *) klass)->visit_class = (void (*) (ValaCodeVisitor *, ValaClass*)) ide_vala_locator_real_visit_class;
	((ValaCodeVisitorClass *) klass)->visit_struct = (void (*) (ValaCodeVisitor *, ValaStruct*)) ide_vala_locator_real_visit_struct;
	((ValaCodeVisitorClass *) klass)->visit_interface = (void (*) (ValaCodeVisitor *, ValaInterface*)) ide_vala_locator_real_visit_interface;
	((ValaCodeVisitorClass *) klass)->visit_method = (void (*) (ValaCodeVisitor *, ValaMethod*)) ide_vala_locator_real_visit_method;
	((ValaCodeVisitorClass *) klass)->visit_creation_method = (void (*) (ValaCodeVisitor *, ValaCreationMethod*)) ide_vala_locator_real_visit_creation_method;
	((ValaCodeVisitorClass *) klass)->visit_property = (void (*) (ValaCodeVisitor *, ValaProperty*)) ide_vala_locator_real_visit_property;
	((ValaCodeVisitorClass *) klass)->visit_property_accessor = (void (*) (ValaCodeVisitor *, ValaPropertyAccessor*)) ide_vala_locator_real_visit_property_accessor;
	((ValaCodeVisitorClass *) klass)->visit_constructor = (void (*) (ValaCodeVisitor *, ValaConstructor*)) ide_vala_locator_real_visit_constructor;
	((ValaCodeVisitorClass *) klass)->visit_destructor = (void (*) (ValaCodeVisitor *, ValaDestructor*)) ide_vala_locator_real_visit_destructor;
	((ValaCodeVisitorClass *) klass)->visit_if_statement = (void (*) (ValaCodeVisitor *, ValaIfStatement*)) ide_vala_locator_real_visit_if_statement;
	((ValaCodeVisitorClass *) klass)->visit_switch_statement = (void (*) (ValaCodeVisitor *, ValaSwitchStatement*)) ide_vala_locator_real_visit_switch_statement;
	((ValaCodeVisitorClass *) klass)->visit_switch_section = (void (*) (ValaCodeVisitor *, ValaSwitchSection*)) ide_vala_locator_real_visit_switch_section;
	((ValaCodeVisitorClass *) klass)->visit_while_statement = (void (*) (ValaCodeVisitor *, ValaWhileStatement*)) ide_vala_locator_real_visit_while_statement;
	((ValaCodeVisitorClass *) klass)->visit_do_statement = (void (*) (ValaCodeVisitor *, ValaDoStatement*)) ide_vala_locator_real_visit_do_statement;
	((ValaCodeVisitorClass *) klass)->visit_for_statement = (void (*) (ValaCodeVisitor *, ValaForStatement*)) ide_vala_locator_real_visit_for_statement;
	((ValaCodeVisitorClass *) klass)->visit_foreach_statement = (void (*) (ValaCodeVisitor *, ValaForeachStatement*)) ide_vala_locator_real_visit_foreach_statement;
	((ValaCodeVisitorClass *) klass)->visit_try_statement = (void (*) (ValaCodeVisitor *, ValaTryStatement*)) ide_vala_locator_real_visit_try_statement;
	((ValaCodeVisitorClass *) klass)->visit_catch_clause = (void (*) (ValaCodeVisitor *, ValaCatchClause*)) ide_vala_locator_real_visit_catch_clause;
	((ValaCodeVisitorClass *) klass)->visit_lock_statement = (void (*) (ValaCodeVisitor *, ValaLockStatement*)) ide_vala_locator_real_visit_lock_statement;
	((ValaCodeVisitorClass *) klass)->visit_expression_statement = (void (*) (ValaCodeVisitor *, ValaExpressionStatement*)) ide_vala_locator_real_visit_expression_statement;
	((ValaCodeVisitorClass *) klass)->visit_declaration_statement = (void (*) (ValaCodeVisitor *, ValaDeclarationStatement*)) ide_vala_locator_real_visit_declaration_statement;
	((ValaCodeVisitorClass *) klass)->visit_local_variable = (void (*) (ValaCodeVisitor *, ValaLocalVariable*)) ide_vala_locator_real_visit_local_variable;
	((ValaCodeVisitorClass *) klass)->visit_end_full_expression = (void (*) (ValaCodeVisitor *, ValaExpression*)) ide_vala_locator_real_visit_end_full_expression;
	((ValaCodeVisitorClass *) klass)->visit_expression = (void (*) (ValaCodeVisitor *, ValaExpression*)) ide_vala_locator_real_visit_expression;
}


static void
ide_vala_locator_instance_init (IdeValaLocator * self)
{
	self->priv = ide_vala_locator_get_instance_private (self);
}


static void
ide_vala_locator_finalize (ValaCodeVisitor * obj)
{
	IdeValaLocator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, IDE_TYPE_VALA_LOCATOR, IdeValaLocator);
	_vala_code_node_unref0 (self->priv->innermost);
	VALA_CODE_VISITOR_CLASS (ide_vala_locator_parent_class)->finalize (obj);
}


GType
ide_vala_locator_get_type (void)
{
	return ide_vala_locator_type_id;
}


GType
ide_vala_locator_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (IdeValaLocatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ide_vala_locator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IdeValaLocator), 0, (GInstanceInitFunc) ide_vala_locator_instance_init, NULL };
	ide_vala_locator_type_id = g_type_module_register_type (module, VALA_TYPE_CODE_VISITOR, "IdeValaLocator", &g_define_type_info, 0);
	IdeValaLocator_private_offset = sizeof (IdeValaLocatorPrivate);
	return ide_vala_locator_type_id;
}



